(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var Random = Package.random.Random;
var _ = Package.underscore._;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPermissions, path;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-permissions":{"permissions.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-permissions/permissions.js                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
SandstormPermissions = {};                                                                                             // 19
                                                                                                                       //
var PermissionSet = function () {                                                                                      //
  // A wrapper around an array of booleans representing a set of permissions like "read" or                            //
  // "write". This might represent the permissions held by some user on some grain, or it might                        //
  // represent the permissions that one user has chosen to share with another user.                                    //
  //                                                                                                                   //
  // In our model, permissions are independent. You can have "read" without "write" and you can                        //
  // have "write" without "read". Many apps don't actually allow arbitrary permutations, and                           //
  // instead define "roles" like "editor" or "viewer", where "editor" implies both read and write                      //
  // permission while "viewer" implies only read. Roles, however, are just aliases for sets of                         //
  // permissions; all actual computation is done on permissions.                                                       //
                                                                                                                       //
  function PermissionSet(array) {                                                                                      // 32
    (0, _classCallCheck3["default"])(this, PermissionSet);                                                             //
                                                                                                                       //
    if (!array) {                                                                                                      // 33
      this.array = [];                                                                                                 // 34
    } else if (array instanceof Array) {                                                                               //
      this.array = array.slice(0);                                                                                     // 36
    } else {                                                                                                           //
      throw new Error("don't know how to interpret as PermissionSet: " + array);                                       // 38
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  PermissionSet.fromRoleAssignment = function () {                                                                     // 21
    function fromRoleAssignment(roleAssignment, viewInfo) {                                                            //
      // Create a PermissionSet based on a ViewSharingLink.RoleAssignment and a UiView.ViewInfo (as                    //
      // defined in grain.capnp). ViewInfo defines a mapping from roles to permission sets for a                       //
      // particular grain type. RoleAssignment represents the permissions passed from one user to                      //
      // another -- usually it specifies a single role, but sometimes also specifies permissions to                    //
      // add or remove as well.                                                                                        //
      //                                                                                                               //
      // A falsy value for `roleAssignment` is considered equivalent to a "none" value, which means                    //
      // that no role was explicitly chosen, so the default role should be assigned.                                   //
                                                                                                                       //
      var result = new PermissionSet([]);                                                                              // 52
                                                                                                                       //
      if (!roleAssignment || "none" in roleAssignment) {                                                               // 54
        // No role explicitly chosen, e.g. because the app did not define any roles at the time                        //
        // the sharing took place. Assign the default role, if there is one.                                           //
                                                                                                                       //
        if (viewInfo.roles) {                                                                                          // 58
          for (var ii = 0; ii < viewInfo.roles.length; ++ii) {                                                         // 59
            var roleDef = viewInfo.roles[ii];                                                                          // 60
            if (roleDef["default"]) {                                                                                  // 61
              result = new PermissionSet(roleDef.permissions);                                                         // 62
              break;                                                                                                   // 63
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      } else if ("allAccess" in roleAssignment) {                                                                      //
        // All permissions are shared, even if there is no explicitly-defined role for this.                           //
                                                                                                                       //
        var length = 0;                                                                                                // 70
        if (viewInfo.permissions) {                                                                                    // 71
          length = viewInfo.permissions.length;                                                                        // 72
        }                                                                                                              //
                                                                                                                       //
        var array = new Array(length);                                                                                 // 75
        for (var _ii = 0; _ii < array.length; ++_ii) {                                                                 // 76
          array[_ii] = true;                                                                                           // 77
        }                                                                                                              //
                                                                                                                       //
        result = new PermissionSet(array);                                                                             // 80
      } else if ("roleId" in roleAssignment && viewInfo.roles && viewInfo.roles.length > 0) {                          //
        // A specific role was chosen.                                                                                 //
                                                                                                                       //
        var _roleDef = viewInfo.roles[roleAssignment.roleId];                                                          // 84
        if (_roleDef) {                                                                                                // 85
          result = new PermissionSet(_roleDef.permissions);                                                            // 86
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (roleAssignment) {                                                                                            // 90
        // Add or remove specific permissions. This is uncommon.                                                       //
        result.add(new PermissionSet(roleAssignment.addPermissionSet));                                                // 92
        result.remove(new PermissionSet(roleAssignment.removePermissionSet));                                          // 93
      }                                                                                                                //
                                                                                                                       //
      return result;                                                                                                   // 96
    }                                                                                                                  //
                                                                                                                       //
    return fromRoleAssignment;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.isEmpty = function () {                                                                      // 21
    function isEmpty() {                                                                                               //
      var result = true;                                                                                               // 100
      this.array.forEach(function (p) {                                                                                // 101
        if (p) {                                                                                                       // 102
          result = false;                                                                                              // 103
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      return result;                                                                                                   // 107
    }                                                                                                                  //
                                                                                                                       //
    return isEmpty;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.isSubsetOf = function () {                                                                   // 21
    function isSubsetOf(other) {                                                                                       //
      check(other, PermissionSet);                                                                                     // 111
      for (var ii = 0; ii < this.array.length; ++ii) {                                                                 // 112
        var mine = this.array[ii];                                                                                     // 113
        var yours = other.array[ii] || false;                                                                          // 114
        if (mine && !yours) {                                                                                          // 115
          return false;                                                                                                // 116
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return true;                                                                                                     // 120
    }                                                                                                                  //
                                                                                                                       //
    return isSubsetOf;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  // Methods for mutating a PermissionSet by combining it with another PermissionSet.                                  //
  // These return a boolean indicating whether the operation had any effect.                                           //
                                                                                                                       //
  PermissionSet.prototype.add = function () {                                                                          // 21
    function add(other) {                                                                                              //
      check(other, PermissionSet);                                                                                     // 127
      var changed = false;                                                                                             // 128
      for (var ii = 0; ii < other.array.length; ++ii) {                                                                // 129
        var old = !!this.array[ii];                                                                                    // 130
        this.array[ii] = !!this.array[ii] || other.array[ii];                                                          // 131
        if (old !== this.array[ii]) {                                                                                  // 132
          changed = true;                                                                                              // 133
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  // 137
    }                                                                                                                  //
                                                                                                                       //
    return add;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.remove = function () {                                                                       // 21
    function remove(other) {                                                                                           //
      check(other, PermissionSet);                                                                                     // 141
      var changed = false;                                                                                             // 142
      for (var ii = 0; ii < other.array.length && ii < this.array.length; ++ii) {                                      // 143
        var old = !!this.array[ii];                                                                                    // 144
        this.array[ii] = !!this.array[ii] && !other.array[ii];                                                         // 145
        if (old !== this.array[ii]) {                                                                                  // 146
          changed = true;                                                                                              // 147
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  // 151
    }                                                                                                                  //
                                                                                                                       //
    return remove;                                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  PermissionSet.prototype.intersect = function () {                                                                    // 21
    function intersect(other) {                                                                                        //
      check(other, PermissionSet);                                                                                     // 155
      var changed = false;                                                                                             // 156
      for (var ii = 0; ii < this.array.length; ++ii) {                                                                 // 157
        var old = !!this.array[ii];                                                                                    // 158
        this.array[ii] = !!this.array[ii] && other.array[ii];                                                          // 159
        if (old !== this.array[ii]) {                                                                                  // 160
          changed = true;                                                                                              // 161
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  // 165
    }                                                                                                                  //
                                                                                                                       //
    return intersect;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  return PermissionSet;                                                                                                //
}();                                                                                                                   //
                                                                                                                       //
var RequirementSet = function () {                                                                                     //
  // A conjunction of permissions for identities on grains.                                                            //
  //                                                                                                                   //
  // This typically represents a set of `MembraneRequirement`s, as defined in `supervisor.capnp`.                      //
  // These represent conditions under which some connection formed between grains remains valid.                       //
  // When a capability travels from grain to grain, it passes across these connections -- if any                       //
  // of the connections becomes invalid (is revoked), then the capability must be revoked as well.                     //
  // The word "membrane" comes from the concept of revokable membranes; the capability is passing                      //
  // across such membranes as it travels.                                                                              //
  //                                                                                                                   //
  // For example, a RequirementSet might represent the statement "Alice has read access to Foo, Bob                    //
  // has write access to Foo, and Bob has read access to Bar". Specifically, this example situation                    //
  // would come about if:                                                                                              //
  // - Bob used his read access to Bar to extract a capability from it.                                                //
  // - Bob embedded that capability into Foo, using his write access.                                                  //
  // - Alice extracted the capability from Foo, using her read access.                                                 //
  // If any of these permissions are revoked, then the capability needs to be revoked as well.                         //
                                                                                                                       //
  function RequirementSet() {                                                                                          // 187
    (0, _classCallCheck3["default"])(this, RequirementSet);                                                            //
                                                                                                                       //
    this.permissionsHeldRequirements = {};                                                                             // 188
    // Two-level map. Maps a pair of a grain ID and an identity ID to a PermissionSet.                                 //
                                                                                                                       //
    this.userIsAdminRequirements = {};                                                                                 // 187
    // Map from account ID to boolean. Represents a set of `userIsAdmin` requirements.                                 //
                                                                                                                       //
    this.tokenValidRequirements = {};                                                                                  // 187
    // Map from token ID to boolean. Represents a set of `tokenValid` requirements.                                    //
  }                                                                                                                    // 187
                                                                                                                       //
  RequirementSet.prototype.isEmpty = function () {                                                                     // 169
    function isEmpty() {                                                                                               //
      for (var tokenId in meteorBabelHelpers.sanitizeForInObject(this.tokenValidRequirements)) {                       // 199
        return false;                                                                                                  // 200
      }                                                                                                                //
                                                                                                                       //
      for (var grainId in meteorBabelHelpers.sanitizeForInObject(this.permissionsHeldRequirements)) {                  // 203
        if (Object.keys(this.permissionsHeldRequirements[grainId]).length > 0) {                                       // 204
          return false;                                                                                                // 205
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return true;                                                                                                     // 209
    }                                                                                                                  //
                                                                                                                       //
    return isEmpty;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.addRequirements = function () {                                                             // 169
    function addRequirements(requirements) {                                                                           //
      var _this = this;                                                                                                //
                                                                                                                       //
      // Updates this RequirementSet to include the permissions required by `requirements`, which                      //
      // is a decoded Cap'n Proto List(MembraneRequirement).                                                           //
                                                                                                                       //
      if (!requirements) return;                                                                                       // 216
      requirements.forEach(function (requirement) {                                                                    // 217
        if (requirement.permissionsHeld) {                                                                             // 218
          var grainId = requirement.permissionsHeld.grainId;                                                           // 219
          var identityId = requirement.permissionsHeld.identityId;                                                     // 220
          var permissions = new PermissionSet(requirement.permissionsHeld.permissions);                                // 221
          _this._ensureEntryExists(grainId, identityId);                                                               // 222
          _this.permissionsHeldRequirements[grainId][identityId].add(permissions);                                     // 223
        } else if (requirement.userIsAdmin) {                                                                          //
          _this.userIsAdminRequirements[requirement.userIsAdmin] = true;                                               // 225
        } else if (requirement.tokenValid) {                                                                           //
          _this.tokenValidRequirements[requirement.tokenValid] = true;                                                 // 227
        } else {                                                                                                       //
          throw new Error("unsupported requirement: " + JSON.toString(requirement));                                   // 229
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return addRequirements;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype._ensureEntryExists = function () {                                                          // 169
    function _ensureEntryExists(grainId, identityId) {                                                                 //
      check(grainId, String);                                                                                          // 235
      check(identityId, String);                                                                                       // 236
                                                                                                                       //
      if (!this.permissionsHeldRequirements[grainId]) {                                                                // 238
        this.permissionsHeldRequirements[grainId] = {};                                                                // 239
      }                                                                                                                //
                                                                                                                       //
      if (!this.permissionsHeldRequirements[grainId][identityId]) {                                                    // 242
        this.permissionsHeldRequirements[grainId][identityId] = new PermissionSet([]);                                 // 243
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return _ensureEntryExists;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.getGrainIds = function () {                                                                 // 169
    function getGrainIds() {                                                                                           //
      return Object.keys(this.permissionsHeldRequirements);                                                            // 248
    }                                                                                                                  //
                                                                                                                       //
    return getGrainIds;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.getTokenIds = function () {                                                                 // 169
    function getTokenIds() {                                                                                           //
      return Object.keys(this.tokenValidRequirements);                                                                 // 252
    }                                                                                                                  //
                                                                                                                       //
    return getTokenIds;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  RequirementSet.prototype.forEach = function () {                                                                     // 169
    function forEach(func) {                                                                                           //
      for (var tokenId in meteorBabelHelpers.sanitizeForInObject(this.tokenValidRequirements)) {                       // 256
        func({ tokenValid: tokenId });                                                                                 // 257
      }                                                                                                                //
                                                                                                                       //
      for (var accountId in meteorBabelHelpers.sanitizeForInObject(this.userIsAdminRequirements)) {                    // 260
        func({ userIsAdmin: accountId });                                                                              // 261
      }                                                                                                                //
                                                                                                                       //
      for (var grainId in meteorBabelHelpers.sanitizeForInObject(this.permissionsHeldRequirements)) {                  // 264
        for (var identityId in meteorBabelHelpers.sanitizeForInObject(this.permissionsHeldRequirements[grainId])) {    // 265
          var permissions = this.permissionsHeldRequirements[grainId][identityId];                                     // 266
          func({ permissionsHeld: { grainId: grainId,                                                                  // 267
              identityId: identityId,                                                                                  // 269
              permissionSet: permissions                                                                               // 270
            }                                                                                                          //
          });                                                                                                          //
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return forEach;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  return RequirementSet;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
// A permission ID is either the string "canAccess", corresponding to the implicit "can access                         //
// the grain at all" permission, or a non-negative integer, corresponding to a permission                              //
// defined by the app in its manifest.                                                                                 //
                                                                                                                       //
                                                                                                                       //
var PermissionId = Match.OneOf("canAccess", Match.Integer);                                                            // 281
                                                                                                                       //
function forEachPermission(permissions, func) {                                                                        // 283
  // Calls `func` on "canAccess" and each permission ID that corresponds to a `true`                                   //
  // value in `permissions`.                                                                                           //
  check(permissions, [Boolean]);                                                                                       // 286
  func("canAccess");                                                                                                   // 287
  for (var ii = 0; ii < permissions.length; ++ii) {                                                                    // 288
    if (permissions[ii]) {                                                                                             // 289
      func(ii);                                                                                                        // 290
    }                                                                                                                  //
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
// A vertex is a principal in the sharing graph. A "vertex ID" is either "i:" + an identity ID,                        //
// or "t:" + a token ID. In some limited contexts, "o:Owner" is also allowed, signifying the                           //
// *account* of the grain owner, from which all permissions flow.                                                      //
                                                                                                                       //
function vertexIdOfTokenOwner(token) {                                                                                 // 299
  // Returns which vertex recieves permissions from this token.                                                        //
                                                                                                                       //
  var result = "t:" + token._id; // the bearer of the token                                                            // 302
  if (token.owner && token.owner.user) {                                                                               // 299
    result = "i:" + token.owner.user.identityId; // the identity that owns the token                                   // 304
  }                                                                                                                    // 303
                                                                                                                       //
  return result;                                                                                                       // 307
}                                                                                                                      //
                                                                                                                       //
var Variable =                                                                                                         //
// Our permissions computation can be framed as a propositional HORNSAT problem; this `Variable`                       //
// class represents a variable in that sense. There is a variable for every (grain ID, vertex ID,                      //
// permission ID) triple. There is also a variable for every non-UiView ApiToken, to account for                       //
// `tokenValid` requirements. In any given computation, we only explicitly construct those                             //
// variables that we know might actually be relevant to the result.                                                    //
//                                                                                                                     //
// The value of a variable represents an answer to the question "does this vertex in the sharing                       //
// graph receive this permission at this grain?" We start out by setting all variables to `false`,                     //
// and we only set a variable to `true` when an edge in the sharing graph forces us to. If                             //
// this forward-chaining eventually forces us to set our end goal variables to `true`, then the                        //
// HORNSAT problem is unsatisfiable and we have proved what we wanted. Otherwise, the HORNSAT                          //
// problem is satisfiable, i.e. there is a consistent way to set values to variables in which                          //
// our goal nodes do *not* receive the permissions we wanted them to receive.                                          //
                                                                                                                       //
function () {                                                                                                          //
  function Variable() {                                                                                                // 325
    (0, _classCallCheck3["default"])(this, Variable);                                                                  //
                                                                                                                       //
    this.value = false;                                                                                                // 326
                                                                                                                       //
    this.directDependents = [];                                                                                        // 328
    // List of token IDs for outgoing edges that need to be looked at once this variable gets set                      //
    // to `true`.                                                                                                      //
                                                                                                                       //
    this.requirementDependents = [];                                                                                   // 325
    // List of token IDs for tokens that have requirements that get fulfilled once this variable                       //
    // gets set to `true`.                                                                                             //
  }                                                                                                                    // 325
                                                                                                                       //
  return Variable;                                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
var ActiveToken = function () {                                                                                        //
  // An "active token" is one that we allow to propagate permissions because we've decided                             //
  // that it might be relevant to our current computation. This class tracks which permissions                         //
  // the token can carry, which of those permissions we've actually proved to arrive at the source                     //
  // end of the token, and how many of the token's requirements are still unmet.                                       //
                                                                                                                       //
  function ActiveToken(tokenId, requirements, numUnmetRequirements, permissions, grainId, recipientId) {               // 344
    (0, _classCallCheck3["default"])(this, ActiveToken);                                                               //
                                                                                                                       //
    check(tokenId, String);                                                                                            // 345
    check(numUnmetRequirements, Match.Integer);                                                                        // 346
    check(grainId, String);                                                                                            // 347
    check(recipientId, String);                                                                                        // 348
                                                                                                                       //
    check(permissions, [Boolean]);                                                                                     // 350
    // The permissions that this token is capable of carrying, in addition to the implicit                             //
    // "canAccess" permission.                                                                                         //
                                                                                                                       //
    this.tokenId = tokenId;                                                                                            // 344
    this.requirements = requirements;                                                                                  // 355
    this.grainId = grainId;                                                                                            // 356
    this.recipientId = recipientId;                                                                                    // 357
                                                                                                                       //
    this.numUnmetRequirements = numUnmetRequirements;                                                                  // 359
    // How many of this token's requirements we have not yet proven to be met.                                         //
                                                                                                                       //
    this.receivedPermissions = new Array();                                                                            // 344
    // A map from permission ID to boolean. If a permission ID is present in this map,                                 //
    // then this token's roleAssignment includes that permission. If the corresponding                                 //
    // value is `true`, then we've proven that this token receives this permission and                                 //
    // therefore propagates it if the requirements are met.                                                            //
                                                                                                                       //
    this.receivedPermissions.canAccess = false;                                                                        // 344
    for (var ii = 0; ii < permissions.length; ++ii) {                                                                  // 369
      if (permissions[ii]) {                                                                                           // 370
        this.receivedPermissions[ii] = false;                                                                          // 371
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  ActiveToken.prototype.requirementsAreMet = function () {                                                             // 338
    function requirementsAreMet() {                                                                                    //
      // Have we yet proved that all of this token's requirements are met?                                             //
      return this.numUnmetRequirements == 0;                                                                           // 378
    }                                                                                                                  //
                                                                                                                       //
    return requirementsAreMet;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  ActiveToken.prototype.decrementRequirements = function () {                                                          // 338
    function decrementRequirements(context) {                                                                          //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      // Decrements the number of unmet requirements of this token.                                                    //
      check(context, Context);                                                                                         // 383
      this.numUnmetRequirements -= 1;                                                                                  // 384
      if (this.numUnmetRequirements < 0) {                                                                             // 385
        throw new Meteor.Error(500, "numUnmetRequirements is negative");                                               // 386
      }                                                                                                                //
                                                                                                                       //
      if (this.requirementsAreMet()) {                                                                                 // 389
        // This was the last missing requirement for this token, therefore we've triggered the                         //
        // outgoing edges from the token corresponding to each known incoming permission.                              //
        this.forEachReceivedPermission(function (permissionId) {                                                       // 392
          // We've triggered a new edge! Push it onto the queue.                                                       //
          context.setToTrueStack.push({ grainId: _this2.grainId,                                                       // 394
            vertexId: _this2.recipientId,                                                                              // 395
            permissionId: permissionId,                                                                                // 396
            responsibleTokenId: _this2.tokenId });                                                                     // 397
        });                                                                                                            //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return decrementRequirements;                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  ActiveToken.prototype.setReceivesPermission = function () {                                                          // 338
    function setReceivesPermission(permissionId, context) {                                                            //
      // Records that this token receives a permission.                                                                //
      check(permissionId, PermissionId);                                                                               // 404
      check(context, Context);                                                                                         // 405
      if (permissionId in this.receivedPermissions) {                                                                  // 406
        this.receivedPermissions[permissionId] = true;                                                                 // 407
      }                                                                                                                //
                                                                                                                       //
      if (this.numUnmetRequirements == 0) {                                                                            // 410
        context.setToTrueStack.push({ grainId: this.grainId,                                                           // 411
          vertexId: this.recipientId,                                                                                  // 412
          permissionId: permissionId,                                                                                  // 413
          responsibleTokenId: this.tokenId });                                                                         // 414
      } else {                                                                                                         //
        // Since we know permissions flow to this token, and the token is active (meaning it                           //
        // may be relevant to the overall computation), we now know that it's worth checking                           //
        // the token's requirements. Add them to `unmetRequirements`. Note that these requirement                      //
        // could actually be ones that we've checked already, but we'll figure that out once                           //
        // processUnmetRequirements() runs and discovers it isn't activating any new tokens.                           //
        //                                                                                                             //
        // TODO(perf): This is an overestimate. It might be worthwhile to keep track of which                          //
        //   requirements are already met, so that we don't need to add them here.                                     //
                                                                                                                       //
        context.unmetRequirements.addRequirements(this.requirements);                                                  // 425
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return setReceivesPermission;                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  ActiveToken.prototype.forEachReceivedPermission = function () {                                                      // 338
    function forEachReceivedPermission(func) {                                                                         //
      // Calls `func` on each permission ID that we've proven this token receives.                                     //
                                                                                                                       //
      if (this.receivedPermissions.canAccess) {                                                                        // 432
        func("canAccess");                                                                                             // 433
      }                                                                                                                //
                                                                                                                       //
      // Note: Array.forEach() does hit the "canAccess" permission ID.                                                 //
      this.receivedPermissions.forEach(function (received, permissionId) {                                             // 429
        if (received) {                                                                                                // 438
          func(permissionId);                                                                                          // 439
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return forEachReceivedPermission;                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  return ActiveToken;                                                                                                  //
}();                                                                                                                   //
                                                                                                                       //
var Context = function () {                                                                                            //
  // An ongoing permissions computation, including cached database state.                                              //
                                                                                                                       //
  function Context() {                                                                                                 // 448
    (0, _classCallCheck3["default"])(this, Context);                                                                   //
                                                                                                                       //
    this.grains = {}; // Map from grain ID to entry in Grains table.                                                   // 449
    this.userIdentityIds = {}; // Map from account ID to list of linked identity IDs.                                  // 448
    this.adminUsers = {}; // Set of account IDs for admins.                                                            // 448
    this.tokensById = {}; // Map from token ID to token.                                                               // 448
    this.tokensByRecipient = {}; // Map from grain ID and identity ID to token array.                                  // 448
                                                                                                                       //
    this.variables = {};                                                                                               // 448
    // GrainId -> VertexId -> PermissionId -> Variable                                                                 //
    //                                                                                                                 //
    // We have a special fake grain ID "tokenValid", where we store the variables that track                           //
    // `tokenValid` requirements. Only the "canAccess" permission makes sense for that fake grain.                     //
                                                                                                                       //
    this.userIsAdminVariables = {};                                                                                    // 448
    // Account ID -> Variable                                                                                          //
                                                                                                                       //
    this.activeTokens = {}; // TokenId -> ActiveToken                                                                  // 448
                                                                                                                       //
    this.setToTrueStack = [];                                                                                          // 448
    // Variables enqueued to be set to true.                                                                           //
    // Array of { grainId: String, vertexId: String, permissionId: PermissionId,                                       //
    //            responsibleTokenId: Optional(String) }                                                               //
                                                                                                                       //
    this.unmetRequirements = new RequirementSet();                                                                     // 448
    // As we run our forward-chaining algorithm, when we encounter a token with unmet requirements                     //
    // we add those requirements to this set. Then, if we find that our current knowledge base                         //
    // is not large enough to prove our goal, we can expand our search by following these                              //
    // requirements backwards and activating tokens that might help prove that they are met.                           //
    // `unmetRequirements` is allowed to be an overestimate -- in fact, when adding requirements                       //
    // to `unmetRequirements` we generally do not check if they had already been proven. The next                      //
    // run of processUnmetRequirements(), however, will find that all of the tokens activated by                       //
    // the requirements were already active.                                                                           //
  }                                                                                                                    // 448
                                                                                                                       //
  Context.prototype.reset = function () {                                                                              // 445
    function reset() {                                                                                                 //
      // Resets all state except this.grains, this.userIdentityIds, and this.adminUsers.                               //
      this.tokensById = {};                                                                                            // 484
      this.tokensByRecipient = {};                                                                                     // 485
      this.unmetRequirements = new RequirementSet();                                                                   // 486
      this.setToTrueStack = [];                                                                                        // 487
      this.variables = {};                                                                                             // 488
      this.activeTokens = {};                                                                                          // 489
    }                                                                                                                  //
                                                                                                                       //
    return reset;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.addToken = function () {                                                                           // 445
    function addToken(token) {                                                                                         //
      // Adds a token to `this.tokensById`. If the token is a UiView, also adds it to                                  //
      // `this.tokensByRecipient`. Does not activate the token.                                                        //
                                                                                                                       //
      var isUiView = token.grainId && !token.objectId;                                                                 // 496
                                                                                                                       //
      if (this.tokensById[token._id]) return;                                                                          // 498
                                                                                                                       //
      this.tokensById[token._id] = token;                                                                              // 500
      if (isUiView && token.owner && token.owner.user) {                                                               // 501
        if (!this.tokensByRecipient[token.grainId]) {                                                                  // 502
          this.tokensByRecipient[token.grainId] = {};                                                                  // 503
        }                                                                                                              //
                                                                                                                       //
        if (!this.tokensByRecipient[token.grainId][token.owner.user.identityId]) {                                     // 506
          this.tokensByRecipient[token.grainId][token.owner.user.identityId] = [];                                     // 507
        }                                                                                                              //
                                                                                                                       //
        this.tokensByRecipient[token.grainId][token.owner.user.identityId].push(token);                                // 510
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return addToken;                                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.addGrains = function () {                                                                          // 445
    function addGrains(db, grainIds) {                                                                                 //
      var _this3 = this;                                                                                               //
                                                                                                                       //
      // Retrieves grains from the database.                                                                           //
                                                                                                                       //
      check(db, SandstormDb);                                                                                          // 517
      check(grainIds, [String]);                                                                                       // 518
      if (grainIds.length == 0) return; // Nothing to do.                                                              // 519
                                                                                                                       //
      db.collections.grains.find({ _id: { $in: grainIds } }).forEach(function (grain) {                                // 514
        _this3.grains[grain._id] = grain;                                                                              // 522
        if (!_this3.userIdentityIds[grain.userId]) {                                                                   // 523
          _this3.userIdentityIds[grain.userId] = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      var query = { grainId: { $in: grainIds },                                                                        // 529
        revoked: { $ne: true }, objectId: { $exists: false } };                                                        // 530
      db.collections.apiTokens.find(query).forEach(function (token) {                                                  // 531
        return _this3.addToken(token);                                                                                 //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return addGrains;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.addTokensFromCursor = function () {                                                                // 445
    function addTokensFromCursor(cursor) {                                                                             //
      var _this4 = this;                                                                                               //
                                                                                                                       //
      cursor.forEach(function (token) {                                                                                // 535
        return _this4.addToken(token);                                                                                 //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return addTokensFromCursor;                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateOwnerEdges = function () {                                                                 // 445
    function activateOwnerEdges(grainId, edges) {                                                                      //
      var _this5 = this;                                                                                               //
                                                                                                                       //
      check(edges, [{ identityId: String, role: SandstormDb.prototype.roleAssignmentPattern }]);                       // 539
                                                                                                                       //
      edges.forEach(function (edge) {                                                                                  // 541
        var viewInfo = _this5.grains[grainId].cachedViewInfo || {};                                                    // 542
        var permissions = PermissionSet.fromRoleAssignment(edge.role, viewInfo);                                       // 543
        var vertexId = "i:" + edge.identityId;                                                                         // 544
        forEachPermission(permissions.array, function (permissionId) {                                                 // 545
          _this5.setToTrueStack.push({ grainId: grainId, vertexId: vertexId,                                           // 546
            permissionId: permissionId });                                                                             // 547
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return activateOwnerEdges;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.registerInterestInRequirements = function () {                                                     // 445
    function registerInterestInRequirements(tokenId, requirements) {                                                   //
      var _this6 = this;                                                                                               //
                                                                                                                       //
      // Add all requirements.                                                                                         //
      var numUnmetRequirements = 0;                                                                                    // 554
      if (requirements) {                                                                                              // 555
        requirements.forEach(function (requirement) {                                                                  // 556
          if (requirement.permissionsHeld) {                                                                           // 557
            (function () {                                                                                             //
              var reqGrainId = requirement.permissionsHeld.grainId;                                                    // 558
              var reqVertexId = "i:" + requirement.permissionsHeld.identityId;                                         // 559
              var reqPermissions = requirement.permissionsHeld.permissions || [];                                      // 560
                                                                                                                       //
              forEachPermission(reqPermissions, function (permissionId) {                                              // 562
                var variable = _this6.getVariable(reqGrainId, reqVertexId, permissionId);                              // 563
                if (!variable.value) {                                                                                 // 564
                  // This requirement hasn't been proven yet. We add it to the variable's list of                      //
                  // dependents so that we get notified when that variable is proven, and we increment                 //
                  // numUnmetRequirements to indicate how many notifications we need to get before we                  //
                  // know all requirements are satisfied.                                                              //
                  numUnmetRequirements += 1;                                                                           // 569
                  variable.requirementDependents.push(tokenId);                                                        // 570
                }                                                                                                      //
              });                                                                                                      //
            })();                                                                                                      //
          } else if (requirement.userIsAdmin) {                                                                        //
            var accountId = requirement.userIsAdmin;                                                                   // 574
            var variable = _this6.getUserIsAdminVariable(accountId);                                                   // 575
            if (!variable.value) {                                                                                     // 576
              numUnmetRequirements += 1;                                                                               // 577
              variable.requirementDependents.push(tokenId);                                                            // 578
            }                                                                                                          //
          } else if (requirement.tokenValid) {                                                                         //
            var reqTokenId = requirement.tokenValid;                                                                   // 581
            var _variable = _this6.getVariable("tokenValid", "t:" + reqTokenId, "canAccess");                          // 582
            if (!_variable.value) {                                                                                    // 583
              numUnmetRequirements += 1;                                                                               // 584
              _variable.requirementDependents.push(tokenId);                                                           // 585
            }                                                                                                          //
          } else {                                                                                                     //
            throw new Error("unknown kind of requirement: " + JSON.stringify(requirement));                            // 588
          }                                                                                                            //
        });                                                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return numUnmetRequirements;                                                                                     // 593
    }                                                                                                                  //
                                                                                                                       //
    return registerInterestInRequirements;                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateToken = function () {                                                                      // 445
    function activateToken(tokenId) {                                                                                  //
      var _this7 = this;                                                                                               //
                                                                                                                       //
      // Includes a new token (which must already be in `this.tokensById`) in our computation. The                     //
      // tricky part here is dealing with our already-accumulated knowledge; we need to compute how                    //
      // many of the token's requirements are currently unmet and whether we need to push anything new                 //
      // onto `setToTrueStack`.                                                                                        //
                                                                                                                       //
      check(tokenId, String);                                                                                          // 602
      if (tokenId in this.activeTokens) {                                                                              // 603
        return false;                                                                                                  // 604
      }                                                                                                                //
                                                                                                                       //
      var token = this.tokensById[tokenId];                                                                            // 607
      var grainId = token.grainId;                                                                                     // 608
      var viewInfo = this.grains[grainId].cachedViewInfo || {};                                                        // 609
      var tokenPermissions = PermissionSet.fromRoleAssignment(token.roleAssignment, viewInfo);                         // 610
                                                                                                                       //
      var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                           // 612
      var recipientId = vertexIdOfTokenOwner(token);                                                                   // 613
                                                                                                                       //
      var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                     // 615
      var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, tokenPermissions.array, grainId, recipientId);
                                                                                                                       //
      // Add all edges represented by this token (one for each permission).                                            //
      forEachPermission(tokenPermissions.array, function (permissionId) {                                              // 596
        var recipientVariable = _this7.getVariable(grainId, recipientId, permissionId);                                // 621
        if (!recipientVariable.value) {                                                                                // 622
          var sharerVariable = _this7.getVariable(grainId, sharerId, permissionId);                                    // 623
          if (!sharerVariable.value) {                                                                                 // 624
            // Not proven yet that the source has this permission, so add to its direct dependents so                  //
            // that we get notified if that changes.                                                                   //
            sharerVariable.directDependents.push(tokenId);                                                             // 627
          } else {                                                                                                     //
            // The source has already been proven.                                                                     //
            activeToken.setReceivesPermission(permissionId, _this7);                                                   // 630
          }                                                                                                            //
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      this.activeTokens[tokenId] = activeToken;                                                                        // 635
                                                                                                                       //
      return true;                                                                                                     // 637
    }                                                                                                                  //
                                                                                                                       //
    return activateToken;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateTokenValidToken = function () {                                                            // 445
    function activateTokenValidToken(tokenId) {                                                                        //
      // Like `activateToken()`, but for a token that appears in a `tokenValid` requirement.                           //
      // Such tokens require some special handling to fit into our computation.                                        //
                                                                                                                       //
      check(tokenId, String);                                                                                          // 644
      if (tokenId in this.activeTokens) {                                                                              // 645
        return false;                                                                                                  // 646
      }                                                                                                                //
                                                                                                                       //
      var token = this.tokensById[tokenId];                                                                            // 649
      if (!token) {                                                                                                    // 650
        return false;                                                                                                  // 651
      }                                                                                                                //
                                                                                                                       //
      var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                     // 654
      var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, [], "tokenValid", "t:" + tokenId);
                                                                                                                       //
      var recipientId = "t:" + tokenId;                                                                                // 658
      var sharerVariable = token.parentToken && this.getVariable("tokenValid", "t:" + token.parentToken, "canAccess");
                                                                                                                       //
      var recipientVariable = this.getVariable("tokenValid", recipientId, "canAccess");                                // 662
      if (!recipientVariable.value) {                                                                                  // 663
        if (!token.parentToken || sharerVariable && sharerVariable.value) {                                            // 664
          // The source has already been proven.                                                                       //
          activeToken.setReceivesPermission("canAccess", this);                                                        // 666
        } else {                                                                                                       //
          // Not proven yet that the source has this permission, so add to its direct dependents so                    //
          // that we get notified if that changes.                                                                     //
          sharerVariable.directDependents.push(tokenId);                                                               // 670
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      this.activeTokens[tokenId] = activeToken;                                                                        // 674
                                                                                                                       //
      return true;                                                                                                     // 676
    }                                                                                                                  //
                                                                                                                       //
    return activateTokenValidToken;                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getVariable = function () {                                                                        // 445
    function getVariable(grainId, vertexId, permissionId) {                                                            //
      check(grainId, String);                                                                                          // 680
      check(vertexId, String);                                                                                         // 681
      check(permissionId, PermissionId);                                                                               // 682
                                                                                                                       //
      if (!this.variables[grainId]) {                                                                                  // 684
        this.variables[grainId] = {};                                                                                  // 685
      }                                                                                                                //
                                                                                                                       //
      if (!this.variables[grainId][vertexId]) {                                                                        // 688
        this.variables[grainId][vertexId] = new Array();                                                               // 689
      }                                                                                                                //
                                                                                                                       //
      if (!this.variables[grainId][vertexId][permissionId]) {                                                          // 692
        this.variables[grainId][vertexId][permissionId] = new Variable();                                              // 693
      }                                                                                                                //
                                                                                                                       //
      return this.variables[grainId][vertexId][permissionId];                                                          // 696
    }                                                                                                                  //
                                                                                                                       //
    return getVariable;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getUserIsAdminVariable = function () {                                                             // 445
    function getUserIsAdminVariable(accountId) {                                                                       //
      check(accountId, String);                                                                                        // 700
                                                                                                                       //
      if (!this.userIsAdminVariables[accountId]) {                                                                     // 702
        this.userIsAdminVariables[accountId] = new Variable();                                                         // 703
      }                                                                                                                //
                                                                                                                       //
      return this.userIsAdminVariables[accountId];                                                                     // 706
    }                                                                                                                  //
                                                                                                                       //
    return getUserIsAdminVariable;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getPermissions = function () {                                                                     // 445
    function getPermissions(grainId, vertexId) {                                                                       //
      // Looks up the permissions that have already been proven for the `vertexId` on `grainId`.                       //
                                                                                                                       //
      check(grainId, String);                                                                                          // 712
      check(vertexId, String);                                                                                         // 713
                                                                                                                       //
      if (!this.getVariable(grainId, vertexId, "canAccess").value) {                                                   // 715
        return null;                                                                                                   // 716
      } else {                                                                                                         //
        var length = this.variables[grainId][vertexId].length;                                                         // 718
        var permissions = new Array(length);                                                                           // 719
        for (var idx = 0; idx < length; ++idx) {                                                                       // 720
          if (this.variables[grainId][vertexId][idx]) {                                                                // 721
            permissions[idx] = !!this.variables[grainId][vertexId][idx].value;                                         // 722
          } else {                                                                                                     //
            permissions[idx] = false;                                                                                  // 724
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        return new PermissionSet(permissions);                                                                         // 728
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return getPermissions;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.runForwardChaining = function () {                                                                 // 445
    function runForwardChaining(grainId, vertexId, permissionSet) {                                                    //
      var _this8 = this;                                                                                               //
                                                                                                                       //
      // Runs forward-chaining, consuming elements from `this.setToTrueStack` and propagating                          //
      // their permissions, until we've proven that `(grainId, vertexId)` has the permissions in                       //
      // `permissionSet`, or until we've exhausted `this.setToTrueStack`.                                              //
      //                                                                                                               //
      // TODO(perf): Exit early if we've already proven that permissionSet is fulfilled.                               //
                                                                                                                       //
      check(grainId, String);                                                                                          // 739
      check(vertexId, String);                                                                                         // 740
      check(permissionSet, PermissionSet);                                                                             // 741
                                                                                                                       //
      if (permissionSet.array.length > 0) {                                                                            // 743
        // Make sure that the result of this call, retrieved through `this.getPermissions()`,                          //
        // will have a full array of permissions, even if they won't all be set to `true`.                             //
        this.getVariable(grainId, vertexId, permissionSet.array.length - 1);                                           // 746
      }                                                                                                                //
                                                                                                                       //
      var _loop = function () {                                                                                        //
        function _loop() {                                                                                             //
          var current = _this8.setToTrueStack.pop();                                                                   // 750
          var variable = _this8.getVariable(current.grainId, current.vertexId, current.permissionId);                  // 751
          if (variable.value) {                                                                                        // 752
            return "continue";                                                                                         // 753
          }                                                                                                            //
                                                                                                                       //
          // For the first time, this vertex is now known to be satisfied.                                             //
          variable.value = true;                                                                                       // 757
                                                                                                                       //
          // For each edge (token) whose source is this vertex, mark that the input permission is                      //
          // fulfilled.                                                                                                //
          variable.responsibleTokenId = current.responsibleTokenId;                                                    // 761
          variable.directDependents.forEach(function (tokenId) {                                                       // 762
            // We know this permission must be met now. We also know that the permission was not met                   //
            // for this token previously becaues a token has exactly one source vertex for each                        //
            // permission, and we're processing that vertex now.                                                       //
                                                                                                                       //
            _this8.activeTokens[tokenId].setReceivesPermission(current.permissionId, _this8);                          // 767
          });                                                                                                          //
                                                                                                                       //
          // For each token that has a requirement on this vertex, mark that one of its requirements                   //
          // has ben fulfilled.                                                                                        //
          variable.requirementDependents.forEach(function (tokenId) {                                                  // 772
            _this8.activeTokens[tokenId].decrementRequirements(_this8);                                                // 773
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        return _loop;                                                                                                  //
      }();                                                                                                             //
                                                                                                                       //
      while (this.setToTrueStack.length > 0) {                                                                         // 749
        var _ret2 = _loop();                                                                                           //
                                                                                                                       //
        if (_ret2 === "continue") continue;                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return this.getPermissions(grainId, vertexId);                                                                   // 777
    }                                                                                                                  //
                                                                                                                       //
    return runForwardChaining;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.activateRelevantTokens = function () {                                                             // 445
    function activateRelevantTokens(grainId, vertexId) {                                                               //
      var _this9 = this;                                                                                               //
                                                                                                                       //
      // Returns true if more computation might yield more progress.                                                   //
                                                                                                                       //
      check(grainId, String);                                                                                          // 783
      check(vertexId, String);                                                                                         // 784
                                                                                                                       //
      var result = false;                                                                                              // 786
      var relevant = computeRelevantTokens(this, grainId, vertexId);                                                   // 787
      this.activateOwnerEdges(grainId, relevant.ownerEdges);                                                           // 788
      relevant.tokenIds.forEach(function (tokenId) {                                                                   // 789
        if (_this9.activateToken(tokenId)) {                                                                           // 790
          result = true;                                                                                               // 791
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      return result;                                                                                                   // 795
    }                                                                                                                  //
                                                                                                                       //
    return activateRelevantTokens;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.processUnmetRequirements = function () {                                                           // 445
    function processUnmetRequirements(db) {                                                                            //
      var _this10 = this;                                                                                              //
                                                                                                                       //
      // Activate all tokens relevant to the requirements in `unmetRequirements`. May do a database                    //
      // query to look up new tokens.                                                                                  //
      //                                                                                                               //
      // Returns true if more computation might yield more progress, i.e., at least one token was                      //
      // newly-activated.                                                                                              //
                                                                                                                       //
      var grainIds = this.unmetRequirements.getGrainIds().filter(function (grainId) {                                  // 805
        return !(grainId in _this10.grains);                                                                           //
      });                                                                                                              //
                                                                                                                       //
      if (db) {                                                                                                        // 808
        this.addGrains(db, grainIds);                                                                                  // 809
      }                                                                                                                //
                                                                                                                       //
      var result = false;                                                                                              // 812
                                                                                                                       //
      // As we process our requirements, we might find new unmet requirments.                                          //
      // We defer processing those until the next time around.                                                         //
      var oldUnmetRequirements = this.unmetRequirements;                                                               // 798
      this.unmetRequirements = new RequirementSet();                                                                   // 817
                                                                                                                       //
      oldUnmetRequirements.forEach(function (req) {                                                                    // 819
        if (req.permissionsHeld) {                                                                                     // 820
          var next = req.permissionsHeld;                                                                              // 821
          // Activate all tokens relevant to this requirement.                                                         //
          // TODO(perf): We're actually overestimating, because we're activating tokens relevant to                    //
          //   *all* permissions rather than just the permissions specified by the requirement. E.g.                   //
          //   if the requirement is that Bob has write access, then tokens which only transmit read                   //
          //   access are not relevant, but we'll end up activating them anyway.                                       //
          if (_this10.activateRelevantTokens(next.grainId, "i:" + next.identityId)) {                                  // 820
            result = true;                                                                                             // 828
          }                                                                                                            //
        } else if (req.tokenValid) {                                                                                   //
          // Active the token and all of its transitive parents.                                                       //
          var currentTokenId = req.tokenValid;                                                                         // 832
          while (true) {                                                                                               // 833
            var currentToken = _this10.tokensById[currentTokenId];                                                     // 834
            if (!currentToken && db) {                                                                                 // 835
              currentToken = db.collections.apiTokens.findOne({ _id: currentTokenId,                                   // 836
                revoked: { $ne: true } });                                                                             // 837
              _this10.tokensById[currentTokenId] = currentToken;                                                       // 838
            }                                                                                                          //
                                                                                                                       //
            if (!currentToken) {                                                                                       // 841
              break;                                                                                                   // 842
            }                                                                                                          //
                                                                                                                       //
            if (_this10.activateTokenValidToken(currentTokenId)) {                                                     // 845
              result = true;                                                                                           // 846
            }                                                                                                          //
                                                                                                                       //
            if (currentToken.parentToken) {                                                                            // 849
              currentTokenId = currentToken.parentToken;                                                               // 850
            } else {                                                                                                   //
              break;                                                                                                   // 852
            }                                                                                                          //
          }                                                                                                            //
        } else if (req.userIsAdmin) {                                                                                  //
          var accountId = req.userIsAdmin;                                                                             // 856
          if (!(accountId in _this10.adminUsers) && db) {                                                              // 857
            Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                             // 858
              _this10.adminUsers[user._id] = true;                                                                     // 859
            });                                                                                                        //
          }                                                                                                            //
                                                                                                                       //
          if (_this10.adminUsers[accountId]) {                                                                         // 863
            var variable = _this10.getUserIsAdminVariable(accountId);                                                  // 864
            variable.value = true;                                                                                     // 865
                                                                                                                       //
            // Might have some requirement dependents. Cannot have any direct depependents.                            //
            variable.requirementDependents.forEach(function (tokenId) {                                                // 863
              result = true;                                                                                           // 869
              _this10.activeTokens[tokenId].decrementRequirements(_this10);                                            // 870
            });                                                                                                        //
          }                                                                                                            //
        } else {                                                                                                       //
          throw new Error("unknown kind of requirement: " + JSON.stringify(req));                                      // 874
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      return result;                                                                                                   // 878
    }                                                                                                                  //
                                                                                                                       //
    return processUnmetRequirements;                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.tryToProve = function () {                                                                         // 445
    function tryToProve(grainId, vertexId, permissionSet, db) {                                                        //
      // Tries to prove that `vertexId` has the given permissions on the given grain. Returns a                        //
      // `PermissionSet` representing the permissions proven, or null if it has not been proved                        //
      // yet that the vertex even has access to the grain.                                                             //
                                                                                                                       //
      check(grainId, String);                                                                                          // 886
      check(vertexId, String);                                                                                         // 887
      check(permissionSet, PermissionSet);                                                                             // 888
      check(db, Match.OneOf(undefined, SandstormDb));                                                                  // 889
      // If `db` is not provided, then this function will make no database queries.                                    //
                                                                                                                       //
      if (db) {                                                                                                        // 881
        this.addGrains(db, [grainId]);                                                                                 // 893
      }                                                                                                                //
                                                                                                                       //
      this.activateRelevantTokens(grainId, vertexId);                                                                  // 896
      while (true) {                                                                                                   // 897
        var result = this.runForwardChaining(grainId, vertexId, permissionSet);                                        // 898
        if (result && permissionSet.isSubsetOf(result)) {                                                              // 899
          return result;                                                                                               // 900
        }                                                                                                              //
                                                                                                                       //
        if (!this.processUnmetRequirements(db)) {                                                                      // 903
          return result;                                                                                               // 904
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return tryToProve;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  Context.prototype.getResponsibleTokens = function () {                                                               // 445
    function getResponsibleTokens(grainId, vertexId) {                                                                 //
      // For the permissions that we've already proven must be held by `vertexId`, transitively finds                  //
      // the tokens that we have used in that proof, including tokens responsible for fulfilling                       //
      // membrane requirements.                                                                                        //
      //                                                                                                               //
      // Whenever we prove a fact, we keep track of the immediately responsible token for that fact,                   //
      // This function works by walking backwards in the sharing graph, following this trail of                        //
      // "responsible tokens".                                                                                         //
      //                                                                                                               //
      // Returns the result as a list of token IDs.                                                                    //
                                                                                                                       //
      check(grainId, String);                                                                                          // 920
      check(vertexId, String);                                                                                         // 921
                                                                                                                       //
      var stack = []; // [{ grainId: String, vertexId: String, permissionId: PermissionId }]                           // 923
      var visited = new Array(); // grainId -> vertexId -> permissionId -> bool;                                       // 909
                                                                                                                       //
      function pushVertex(grainId, vertexId, permissionId) {                                                           // 909
        if (!visited[grainId]) {                                                                                       // 927
          visited[grainId] = {};                                                                                       // 928
        }                                                                                                              //
                                                                                                                       //
        if (!visited[grainId][vertexId]) {                                                                             // 931
          visited[grainId][vertexId] = {};                                                                             // 932
        }                                                                                                              //
                                                                                                                       //
        var vertex = visited[grainId][vertexId];                                                                       // 935
        if (!vertex[permissionId]) {                                                                                   // 936
          vertex[permissionId] = true;                                                                                 // 937
          stack.push({ grainId: grainId, vertexId: vertexId, permissionId: permissionId });                            // 938
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      var neededTokens = {}; // TokenId -> bool                                                                        // 942
                                                                                                                       //
      forEachPermission(this.getPermissions(grainId, vertexId).array, function (permissionId) {                        // 909
        stack.push({ grainId: grainId, vertexId: vertexId, permissionId: permissionId });                              // 945
      });                                                                                                              //
                                                                                                                       //
      while (stack.length > 0) {                                                                                       // 948
        var _current = stack.pop();                                                                                    // 949
        var variable = this.getVariable(_current.grainId, _current.vertexId, _current.permissionId);                   // 950
        var tokenId = variable.responsibleTokenId;                                                                     // 951
        if (tokenId) {                                                                                                 // 952
          var token = this.tokensById[tokenId];                                                                        // 953
                                                                                                                       //
          if (token.grainId && !token.objectId) {                                                                      // 955
            var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                     // 956
            pushVertex(token.grainId, sharerId, _current.permissionId);                                                // 957
          } else if (token.parentToken) {                                                                              //
            pushVertex("tokenValid", "t:" + token.parentToken, "canAccess");                                           // 959
          }                                                                                                            //
                                                                                                                       //
          if (!neededTokens[tokenId]) {                                                                                // 962
            neededTokens[tokenId] = true;                                                                              // 963
            if (token.requirements) {                                                                                  // 964
              token.requirements.forEach(function (requirement) {                                                      // 965
                if (requirement.permissionsHeld) {                                                                     // 966
                  (function () {                                                                                       //
                    var reqVertexId = "i:" + requirement.permissionsHeld.identityId;                                   // 967
                    forEachPermission(requirement.permissionsHeld.permissions, function (permissionId) {               // 968
                      pushVertex(requirement.permissionsHeld.grainId, reqVertexId, permissionId);                      // 969
                    });                                                                                                //
                  })();                                                                                                //
                } else if (requirement.tokenValid) {                                                                   //
                  pushVertex("tokenValid", "t:" + requirement.tokenValid, "canAccess");                                // 972
                }                                                                                                      //
              });                                                                                                      //
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return Object.keys(neededTokens);                                                                                // 980
    }                                                                                                                  //
                                                                                                                       //
    return getResponsibleTokens;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return Context;                                                                                                      //
}();                                                                                                                   //
                                                                                                                       //
function computeRelevantTokens(context, grainId, vertexId) {                                                           // 984
  // Finds all tokens in `context` that could possibly carry permissions of the grain `grainId` to                     //
  // the vertex `vertexId` -- that is, all tokens that are contained in a path starting at the                         //
  // grain owner and ending at `vertexId`. Ignores any requirements that those tokens might be                         //
  // conditional upon.                                                                                                 //
  //                                                                                                                   //
  // Returns an object with two fields:                                                                                //
  //    tokenIds: list of relevant token IDs.                                                                          //
  //    ownerEdges: objects of the form { identityId: String, role: RoleAssignment }, representing                     //
  //                initial pseudo-edges in the graph. `identityId` is typically an identity of                        //
  //                the grain's owning user, but for the case of a legacy public grain it could                        //
  //                be any identity.                                                                                   //
  //                                                                                                                   //
  // Works by traversing the sharing graph twice: first backwards starting from `vertexId`, then                       //
  // forwards starting from the grain owner using only those tokens touched in the first step.                         //
  //                                                                                                                   //
  // `context` contains all the information from the database which is available for now. This call                    //
  // will not make any new database lookups; edges not listed in `context` will not be considered                      //
  // (as if they'd been revoked).                                                                                      //
                                                                                                                       //
  check(context, Context);                                                                                             // 1004
  check(grainId, String);                                                                                              // 1005
  check(vertexId, String);                                                                                             // 1006
                                                                                                                       //
  var grain = context.grains[grainId];                                                                                 // 1008
  var viewInfo = grain.cachedViewInfo || {};                                                                           // 1009
  var ownerIdentityIds = context.userIdentityIds[grain.userId];                                                        // 1010
                                                                                                                       //
  var vertexStack = []; // Vertex IDs that we need to explore.                                                         // 1012
  var visitedVertexIds = {}; // Set of vertex IDs that we have already enqueued to get explored.                       // 984
                                                                                                                       //
  visitedVertexIds[vertexId] = true;                                                                                   // 984
  vertexStack.push(vertexId);                                                                                          // 1016
                                                                                                                       //
  var visitedTokensBySharerId = {};                                                                                    // 1018
  var ownerEdges = [];                                                                                                 // 1019
                                                                                                                       //
  // Repeatedly pop a vertex from the stack, find all its incoming edges (i.e. all other vertexes                      //
  // that share permissions to this vertex), and push those vertexes onto the stack.                                   //
                                                                                                                       // 984
  var _loop2 = function _loop2() {                                                                                     //
    var vertexId = vertexStack.pop();                                                                                  // 1024
                                                                                                                       //
    var incomingEdges = [];                                                                                            // 1026
    // List of edges in the sharing graph ending at this vertex. Each is an object with the fields:                    //
    //     sharerId: The vertex ID of the edge's source.                                                               //
    //     token: the token object backing this edge, if there is one.                                                 //
                                                                                                                       //
    function tokenToEdge(token) {                                                                                      // 1031
      // Convert an ApiToken into an edge.                                                                             //
      return {                                                                                                         // 1033
        token: token,                                                                                                  // 1034
        sharerId: token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId                               // 1035
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    if (vertexId.slice(0, 2) === "o:") {                                                                               // 1039
      // Owner. We don't need to do anything.                                                                          //
      incomingEdges = [];                                                                                              // 1041
    } else if (vertexId.slice(0, 2) === "t:") {                                                                        //
      // A webkey token. Extract it from the context (or ignore if it isn't present).                                  //
      var _token = context.tokensById[vertexId.slice(2)];                                                              // 1044
      if (_token) {                                                                                                    // 1045
        incomingEdges = [tokenToEdge(_token)];                                                                         // 1046
      }                                                                                                                //
    } else if (vertexId.slice(0, 2) === "i:") {                                                                        //
      // An identity.                                                                                                  //
      var identityId = vertexId.slice(2);                                                                              // 1050
      if (ownerIdentityIds.indexOf(identityId) >= 0) {                                                                 // 1051
        // This is one of the owner's identities.                                                                      //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                     // 1053
        ownerEdges.push({ identityId: identityId, role: { allAccess: null } });                                        // 1054
      } else if (!grain["private"]) {                                                                                  //
        // This is a legacy "public" grain, meaning that any user who knows the grain ID receives                      //
        // the grain's default role. If the user doesn't know the grain ID then they are unable                        //
        // to express a request to open the grain in the first place and we'll never get to the                        //
        // point of this permissions computation, so for this purpose we can assume all users                          //
        // have the default role. (Similarly, a user who doesn't know the grain ID couldn't                            //
        // possibly be the subject of any MembraneRequirements against the grain because they                          //
        // have never interacted with the grain and so couldn't have caused such                                       //
        // MembraneRequiments to come about. Note that this is kind of shaky non-local reasoning,                      //
        // but literally no such legacy grain has been created since early 2015 and none will ever                     //
        // be created again, so it's not a huge deal.)                                                                 //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                     // 1066
        ownerEdges.push({ identityId: identityId, role: { none: null } });                                             // 1067
      } else {                                                                                                         //
        // Not a special case. Gather all tokens where this user is the recipient.                                     //
        incomingEdges = ((context.tokensByRecipient[grainId] || {})[vertexId.slice(2)] || []).map(tokenToEdge);        // 1070
      }                                                                                                                //
    } else {                                                                                                           //
      throw new Meteor.Error(500, "Unrecognized vertex ID: " + vertexId);                                              // 1074
    }                                                                                                                  //
                                                                                                                       //
    // For each edge incoming to this vertex, backpropagate this vertex's PermissionFlow to the                        //
    // source vertex, joining it with the edge's constraints.                                                          //
    incomingEdges.forEach(function (edge) {                                                                            // 1079
      var sharerId = edge.sharerId;                                                                                    // 1080
      if (edge.token) {                                                                                                // 1081
        if (!visitedTokensBySharerId[sharerId]) {                                                                      // 1082
          visitedTokensBySharerId[sharerId] = {};                                                                      // 1083
        }                                                                                                              //
                                                                                                                       //
        visitedTokensBySharerId[sharerId][edge.token._id] = edge.token;                                                // 1086
      }                                                                                                                //
                                                                                                                       //
      if (!visitedVertexIds[sharerId]) {                                                                               // 1089
        // Never saw this vertex before.                                                                               //
        visitedVertexIds[sharerId] = true;                                                                             // 1091
        vertexStack.push(sharerId);                                                                                    // 1092
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  while (vertexStack.length > 0) {                                                                                     // 1023
    _loop2();                                                                                                          //
  }                                                                                                                    //
                                                                                                                       //
  // Now walk forward from the owner.                                                                                  //
  var relevantTokens = {};                                                                                             // 984
  var visitedSharers = {};                                                                                             // 1100
                                                                                                                       //
  var sharerStack = [];                                                                                                // 1102
  ownerIdentityIds.forEach(function (identityId) {                                                                     // 1103
    sharerStack.push("i:" + identityId);                                                                               // 1103
  });                                                                                                                  //
  while (sharerStack.length > 0) {                                                                                     // 1104
    var sharerId = sharerStack.pop();                                                                                  // 1105
    for (var tokenId in meteorBabelHelpers.sanitizeForInObject(visitedTokensBySharerId[sharerId])) {                   // 1106
      relevantTokens[tokenId] = true;                                                                                  // 1107
      var token = visitedTokensBySharerId[sharerId][tokenId];                                                          // 1108
      var recipientId = vertexIdOfTokenOwner(token);                                                                   // 1109
                                                                                                                       //
      if (!visitedSharers[recipientId]) {                                                                              // 1111
        visitedSharers[recipientId] = true;                                                                            // 1112
        sharerStack.push(recipientId);                                                                                 // 1113
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return {                                                                                                             // 1118
    tokenIds: Object.keys(relevantTokens),                                                                             // 1119
    ownerEdges: ownerEdges                                                                                             // 1120
  };                                                                                                                   //
}                                                                                                                      //
                                                                                                                       //
var vertexPattern = Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, { grain: Match.ObjectIncluding({ _id: String,
    identityId: Match.OneOf(String, null, undefined) }) });                                                            // 1127
// A vertex in the sharing graph is a principal, e.g. a user (identity) or a token. Complicating                       //
// matters, we may have to traverse sharing graphs for multiple grains in the same computation. A                      //
// token is specific to one grain, but a user of course can have access to multiple grains, so in                      //
// the case of a user we represent the vertex as a (user, grain) pair.                                                 //
//                                                                                                                     //
// TODO(cleanup): Perhaps `grain` should be renamed to `user` or `identity`? In the common case                        //
//   where only a single grain's shares need to be considered, it feels weird to think of the                          //
//   grain ID as being the primary distinguishing feature of the vertex.                                               //
                                                                                                                       //
SandstormPermissions.mayOpenGrain = function (db, vertex) {                                                            // 1137
  // Determines whether the vertex is allowed to open the grain. May make multiple database                            //
  // queries.                                                                                                          //
                                                                                                                       //
  check(vertex, vertexPattern);                                                                                        // 1141
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                                // 1142
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                              // 1143
  var context = new Context();                                                                                         // 1144
  var emptyPermissions = new PermissionSet([]);                                                                        // 1145
  return !!context.tryToProve(grainId, vertexId, emptyPermissions, db);                                                // 1146
};                                                                                                                     //
                                                                                                                       //
SandstormPermissions.grainPermissions = function (db, vertex, viewInfo, onInvalidated) {                               // 1149
  // Computes the set of permissions received by `vertex`. Returns an object with a                                    //
  // `permissions` field containing the computed permissions. If the field is null then                                //
  // the `vertex` does not even have the base "allowed to access at all" permission.                                   //
  //                                                                                                                   //
  // `onInvalidated` is an optional callback. If provided, it will be called when the result                           //
  // has been invalidated. If `onValidated` is provided, the result of `grainPermissions` will                         //
  // have a `observeHandle` field, containing an object with a `stop()` method that must be                            //
  // called once the computation becomes so longer relevant.                                                           //
                                                                                                                       //
  check(db, SandstormDb);                                                                                              // 1159
  check(vertex, vertexPattern);                                                                                        // 1160
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                                // 1161
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                              // 1162
                                                                                                                       //
  var resultPermissions = void 0;                                                                                      // 1164
  var observeHandle = void 0;                                                                                          // 1165
  var onInvalidatedActive = false;                                                                                     // 1166
                                                                                                                       //
  var startTime = new Date();                                                                                          // 1168
  function measureElapsedTime(result) {                                                                                // 1169
    var elapsedMilliseconds = new Date() - startTime;                                                                  // 1170
    if (elapsedMilliseconds > 200) {                                                                                   // 1171
      console.log("Warning: SandstormPermissions.grainPermissions() took " + elapsedMilliseconds + " milliseconds to complete for the vertex " + JSON.stringify(vertex));
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Our computation proceeds in two phases. In the first, we determine which permissions the vertex                   //
  // appears to have and we compute set of tokens which appears to be sufficent to prove those                         //
  // permissions. However, concurrent database modifications may render the computation invalid, so                    //
  // in the second phases we verify that our proof is still valid and arrange for onInvalidated                        //
  // to be called when necessary. This is an optimisistic approach to concurrency. If the                              //
  // verification phase fails, we try again before giving up entirely.                                                 //
  for (var attemptCount = 0; attemptCount < 3; ++attemptCount) {                                                       // 1149
    if (observeHandle) {                                                                                               // 1184
      observeHandle.stop();                                                                                            // 1185
      observeHandle = null;                                                                                            // 1186
    }                                                                                                                  //
                                                                                                                       //
    var context = new Context();                                                                                       // 1189
    var allPermissions = PermissionSet.fromRoleAssignment({ allAccess: null }, viewInfo);                              // 1190
    var firstPhasePermissions = context.tryToProve(grainId, vertexId, allPermissions, db);                             // 1191
                                                                                                                       //
    if (!firstPhasePermissions) return { permissions: null };                                                          // 1193
                                                                                                                       //
    var neededTokens = context.getResponsibleTokens(grainId, vertexId);                                                // 1195
                                                                                                                       //
    // Phase 2: Now let's verify those permissions.                                                                    //
                                                                                                                       //
    context.reset();                                                                                                   // 1183
                                                                                                                       //
    if (neededTokens.length > 0) {                                                                                     // 1201
      (function () {                                                                                                   //
        var guardedOnInvalidated = function guardedOnInvalidated() {                                                   //
          invalidated = true;                                                                                          // 1204
          if (onInvalidatedActive) {                                                                                   // 1205
            onInvalidated();                                                                                           // 1206
          }                                                                                                            //
        };                                                                                                             //
                                                                                                                       //
        var invalidated = false;                                                                                       // 1202
                                                                                                                       //
                                                                                                                       //
        var cursor = db.collections.apiTokens.find({                                                                   // 1210
          _id: { $in: neededTokens },                                                                                  // 1211
          revoked: { $ne: true },                                                                                      // 1212
          objectId: { $exists: false }                                                                                 // 1213
        });                                                                                                            //
                                                                                                                       //
        if (onInvalidated) {                                                                                           // 1216
          observeHandle = cursor.observe({                                                                             // 1217
            changed: function () {                                                                                     // 1218
              function changed(newApiToken, oldApiToken) {                                                             //
                if (!_.isEqual(newApiToken.roleAssignment, oldApiToken.roleAssignment) || !_.isEqual(newApiToken.revoked, oldApiToken.revoked)) {
                  observeHandle.stop();                                                                                // 1221
                  guardedOnInvalidated();                                                                              // 1222
                }                                                                                                      //
              }                                                                                                        //
                                                                                                                       //
              return changed;                                                                                          //
            }(),                                                                                                       //
            removed: function () {                                                                                     // 1226
              function removed(oldApiToken) {                                                                          //
                observeHandle.stop();                                                                                  // 1227
                guardedOnInvalidated();                                                                                // 1228
              }                                                                                                        //
                                                                                                                       //
              return removed;                                                                                          //
            }()                                                                                                        //
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        context.addTokensFromCursor(cursor);                                                                           // 1233
                                                                                                                       //
        // TODO(someday): Also account for linking/unlinking of identities, accounts losing admin                      //
        //   privileges, and legacy public grains becoming private. Currently we do not call                           //
        //   `onInvalided()` on such events. We would need to set up more cursor observers.                            //
      })();                                                                                                            //
    } else {                                                                                                           //
        // Don't need to observe anything.                                                                             //
        observeHandle = {                                                                                              // 1240
          stop: function () {                                                                                          // 1240
            function stop() {}                                                                                         //
                                                                                                                       //
            return stop;                                                                                               //
          }()                                                                                                          //
        };                                                                                                             //
      }                                                                                                                //
                                                                                                                       //
    resultPermissions = context.tryToProve(grainId, vertexId, firstPhasePermissions);                                  // 1243
                                                                                                                       //
    if (resultPermissions && firstPhasePermissions.isSubsetOf(resultPermissions)) {                                    // 1245
      // We've confirmed the permissions that we found the in the first phase. Done!                                   //
      break;                                                                                                           // 1247
    }                                                                                                                  //
  } // for (let attemptCount ...) {                                                                                    //
                                                                                                                       //
  onInvalidatedActive = true;                                                                                          // 1149
  var result = {};                                                                                                     // 1252
  if (resultPermissions) result.permissions = resultPermissions.array;                                                 // 1253
  if (observeHandle) result.observeHandle = observeHandle;                                                             // 1254
  measureElapsedTime();                                                                                                // 1255
  return result;                                                                                                       // 1256
};                                                                                                                     //
                                                                                                                       //
SandstormPermissions.downstreamTokens = function (db, root) {                                                          // 1259
  // Computes a list of the UiView tokens that are downstream in the sharing graph from a given                        //
  // source. The source, `root`, can either be a token or a (grain, user) pair. The exact format                       //
  // of `root` is specified in the `check()` invocation below.                                                         //
  //                                                                                                                   //
  // TODO(someday): Account for membrane requirements in this computation.                                             //
                                                                                                                       //
  check(root, Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, { grain: Match.ObjectIncluding({ _id: String, identityId: String }) }));
                                                                                                                       //
  var result = [];                                                                                                     // 1269
  var tokenStack = [];                                                                                                 // 1270
  var stackedTokens = {};                                                                                              // 1271
  var tokensBySharer = {};                                                                                             // 1272
  var tokensByParent = {};                                                                                             // 1273
  var tokensById = {};                                                                                                 // 1274
                                                                                                                       //
  function addChildren(tokenId) {                                                                                      // 1276
    var children = tokensByParent[tokenId];                                                                            // 1277
    if (children) {                                                                                                    // 1278
      children.forEach(function (child) {                                                                              // 1279
        if (!stackedTokens[child._id]) {                                                                               // 1280
          tokenStack.push(child);                                                                                      // 1281
          stackedTokens[child._id] = true;                                                                             // 1282
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  function addSharedTokens(sharer) {                                                                                   // 1288
    var sharedTokens = tokensBySharer[sharer];                                                                         // 1289
    if (sharedTokens) {                                                                                                // 1290
      sharedTokens.forEach(function (sharedToken) {                                                                    // 1291
        if (!stackedTokens[sharedToken._id]) {                                                                         // 1292
          tokenStack.push(sharedToken);                                                                                // 1293
          stackedTokens[sharedToken._id] = true;                                                                       // 1294
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  var grainId = root.token ? root.token.grainId : root.grain._id;                                                      // 1300
  var grain = db.getGrain(grainId);                                                                                    // 1301
  if (!grain || !grain["private"]) {                                                                                   // 1302
    return result;                                                                                                     // 1302
  }                                                                                                                    //
                                                                                                                       //
  db.collections.apiTokens.find({ grainId: grainId,                                                                    // 1304
    revoked: { $ne: true } }).forEach(function (token) {                                                               // 1305
    tokensById[token._id] = token;                                                                                     // 1306
    if (token.parentToken) {                                                                                           // 1307
      if (!tokensByParent[token.parentToken]) {                                                                        // 1308
        tokensByParent[token.parentToken] = [];                                                                        // 1309
      }                                                                                                                //
                                                                                                                       //
      tokensByParent[token.parentToken].push(token);                                                                   // 1312
    } else if (token.identityId) {                                                                                     //
      if (!tokensBySharer[token.identityId]) {                                                                         // 1314
        tokensBySharer[token.identityId] = [];                                                                         // 1315
      }                                                                                                                //
                                                                                                                       //
      tokensBySharer[token.identityId].push(token);                                                                    // 1318
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  if (root.token) {                                                                                                    // 1322
    addChildren(root.token._id);                                                                                       // 1323
  } else if (root.grain) {                                                                                             //
    addSharedTokens(root.grain.identityId);                                                                            // 1325
  }                                                                                                                    //
                                                                                                                       //
  while (tokenStack.length > 0) {                                                                                      // 1328
    var token = tokenStack.pop();                                                                                      // 1329
    result.push(token);                                                                                                // 1330
    addChildren(token._id);                                                                                            // 1331
    if (token.owner && token.owner.user) {                                                                             // 1332
      addSharedTokens(token.owner.user.identityId);                                                                    // 1333
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return result;                                                                                                       // 1337
};                                                                                                                     //
                                                                                                                       //
var HeaderSafeString = Match.Where(function (str) {                                                                    // 1340
  check(str, String);                                                                                                  // 1341
  return str.match(/^[\x20-\x7E]*$/);                                                                                  // 1342
});                                                                                                                    //
                                                                                                                       //
var DavClass = Match.Where(function (str) {                                                                            // 1345
  check(str, String);                                                                                                  // 1346
  return str.match(/^[a-zA-Z0-9!#$%&'*+.^_`|~-]+$/) || str.match(/^<[\x21-\x7E]*>$/); // supposed to be a URL          // 1347
});                                                                                                                    // 1345
                                                                                                                       //
var ResourceMap = Match.Where(function (map) {                                                                         // 1351
  for (path in meteorBabelHelpers.sanitizeForInObject(map)) {                                                          // 1352
    if (!path.match(/^\/[\x21-\x7E]*$/)) {                                                                             // 1353
      return false;                                                                                                    // 1354
    }                                                                                                                  //
                                                                                                                       //
    check(map[path], {                                                                                                 // 1357
      type: HeaderSafeString,                                                                                          // 1358
      language: Match.Optional(HeaderSafeString),                                                                      // 1359
      encoding: Match.Optional(HeaderSafeString),                                                                      // 1360
      body: String                                                                                                     // 1361
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  return true;                                                                                                         // 1365
});                                                                                                                    //
                                                                                                                       //
var LocalizedString = {                                                                                                // 1368
  defaultText: String,                                                                                                 // 1369
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 1370
};                                                                                                                     //
                                                                                                                       //
SandstormPermissions.createNewApiToken = function (db, provider, grainId, petname, roleAssignment, owner, unauthenticated) {
  // Creates a new UiView API token. If `rawParentToken` is set, creates a child token.                                //
  check(grainId, String);                                                                                              // 1378
  check(petname, String);                                                                                              // 1379
  check(roleAssignment, db.roleAssignmentPattern);                                                                     // 1380
  // Meteor bug #3877: we get null here instead of undefined when we                                                   //
  // explicitly pass in undefined.                                                                                     //
  check(provider, Match.OneOf({ identityId: String, accountId: String }, { rawParentToken: Match.OneOf(String, Buffer) }));
  check(owner, Match.OneOf({ webkey: Match.OneOf(null, { forSharing: Boolean,                                          // 1385
      expiresIfUnusedDuration: Match.Optional(Number)                                                                  // 1387
    }) }, { user: { identityId: String,                                                                                //
      title: String,                                                                                                   // 1390
      renamed: Match.Optional(Boolean),                                                                                // 1391
      upstreamTitle: Match.Optional(String) } }, { grain: { grainId: String,                                           // 1392
      saveLabel: LocalizedString,                                                                                      // 1394
      introducerIdentity: String } }, { frontend: null }));                                                            // 1395
  check(unauthenticated, Match.OneOf(undefined, null, {                                                                // 1397
    options: Match.Optional({ dav: [Match.Optional(DavClass)] }),                                                      // 1398
    resources: Match.Optional(ResourceMap)                                                                             // 1399
  }));                                                                                                                 //
                                                                                                                       //
  if (unauthenticated && JSON.stringify(unauthenticated).length > 4096) {                                              // 1402
    throw new Meteor.Error(400, "Unauthenticated params too large; limit 4kb.");                                       // 1403
  }                                                                                                                    //
                                                                                                                       //
  var grain = db.getGrain(grainId);                                                                                    // 1406
  if (!grain) {                                                                                                        // 1407
    throw new Meteor.Error(403, "Unauthorized", "No grain found.");                                                    // 1408
  }                                                                                                                    //
                                                                                                                       //
  var token = Random.secret();                                                                                         // 1411
  var apiToken = {                                                                                                     // 1412
    _id: Crypto.createHash("sha256").update(token).digest("base64"),                                                   // 1413
    grainId: grainId,                                                                                                  // 1414
    roleAssignment: roleAssignment,                                                                                    // 1415
    petname: petname,                                                                                                  // 1416
    created: new Date(),                                                                                               // 1417
    expires: null                                                                                                      // 1418
  };                                                                                                                   //
                                                                                                                       //
  var result = {};                                                                                                     // 1421
  var parentForSharing = false;                                                                                        // 1422
  if (provider.rawParentToken) {                                                                                       // 1423
    var parentToken = Crypto.createHash("sha256").update(provider.rawParentToken).digest("base64");                    // 1424
    var parentApiToken = db.collections.apiTokens.findOne({ _id: parentToken, grainId: grainId, objectId: { $exists: false } });
    if (!parentApiToken) {                                                                                             // 1427
      throw new Meteor.Error(403, "No such parent token found.");                                                      // 1428
    }                                                                                                                  //
                                                                                                                       //
    if (parentApiToken.forSharing) {                                                                                   // 1431
      parentForSharing = true;                                                                                         // 1432
    }                                                                                                                  //
                                                                                                                       //
    apiToken.identityId = parentApiToken.identityId;                                                                   // 1435
    apiToken.accountId = parentApiToken.accountId;                                                                     // 1436
                                                                                                                       //
    apiToken.parentToken = parentToken;                                                                                // 1438
    result.parentApiToken = parentApiToken;                                                                            // 1439
  } else if (provider.identityId) {                                                                                    //
    apiToken.identityId = provider.identityId;                                                                         // 1441
    apiToken.accountId = provider.accountId;                                                                           // 1442
  }                                                                                                                    //
                                                                                                                       //
  if (owner.webkey) {                                                                                                  // 1445
    // Non-null webkey is a special case not covered in ApiTokenOwner.                                                 //
    // TODO(cleanup): Maybe ApiTokenOwner.webkey should be extended with these fields?                                 //
    apiToken.owner = { webkey: null };                                                                                 // 1448
    apiToken.forSharing = parentForSharing || owner.webkey.forSharing;                                                 // 1449
    if (owner.webkey.expiresIfUnusedDuration) {                                                                        // 1450
      apiToken.expiresIfUnused = new Date(Date.now() + owner.webkey.expiresIfUnusedDuration);                          // 1451
    }                                                                                                                  //
  } else if (owner.user) {                                                                                             //
    var grainInfo = db.getDenormalizedGrainInfo(grainId);                                                              // 1454
    apiToken.owner = {                                                                                                 // 1455
      user: {                                                                                                          // 1456
        identityId: owner.user.identityId,                                                                             // 1457
        title: owner.user.title,                                                                                       // 1458
        denormalizedGrainMetadata: grainInfo                                                                           // 1459
      }                                                                                                                //
    };                                                                                                                 //
                                                                                                                       //
    if (grain.title !== owner.user.title) {                                                                            // 1463
      apiToken.owner.user.upstreamTitle = grain.title;                                                                 // 1464
    }                                                                                                                  //
  } else {                                                                                                             //
    // Note: Also covers the case of `webkey: null`.                                                                   //
    apiToken.owner = owner;                                                                                            // 1468
  }                                                                                                                    //
                                                                                                                       //
  if (unauthenticated) {                                                                                               // 1471
    var apiHost = {                                                                                                    // 1472
      _id: db.apiHostIdHashForToken(token),                                                                            // 1473
      hash2: Crypto.createHash("sha256").update(apiToken._id).digest("base64")                                         // 1474
    };                                                                                                                 //
    if (unauthenticated.options) {                                                                                     // 1476
      apiHost.options = unauthenticated.options;                                                                       // 1477
    }                                                                                                                  //
                                                                                                                       //
    if (unauthenticated.resources) {                                                                                   // 1480
      // Mongo requires keys in objects to be escaped. Ugh.                                                            //
      apiHost.resources = {};                                                                                          // 1482
      for (var key in meteorBabelHelpers.sanitizeForInObject(unauthenticated.resources)) {                             // 1483
        apiHost.resources[SandstormDb.escapeMongoKey(key)] = unauthenticated.resources[key];                           // 1484
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    db.collections.apiHosts.insert(apiHost);                                                                           // 1488
    apiToken.hasApiHost = true;                                                                                        // 1489
  }                                                                                                                    //
                                                                                                                       //
  db.collections.apiTokens.insert(apiToken);                                                                           // 1492
                                                                                                                       //
  result.id = apiToken._id;                                                                                            // 1494
  result.token = token;                                                                                                // 1495
  return result;                                                                                                       // 1496
};                                                                                                                     //
                                                                                                                       //
// Make self-destructing tokens actually self-destruct, so they don't                                                  //
// clutter the token list view.                                                                                        //
SandstormPermissions.cleanupSelfDestructing = function (db) {                                                          // 1501
  return function () {                                                                                                 // 1502
    var now = new Date();                                                                                              // 1503
    db.removeApiTokens({ expiresIfUnused: { $lt: now } });                                                             // 1504
  };                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 1508
  transitiveShares: function () {                                                                                      // 1509
    function transitiveShares(identityId, grainId) {                                                                   // 1509
      check(identityId, String);                                                                                       // 1510
      check(grainId, String);                                                                                          // 1511
      if (this.userId) {                                                                                               // 1512
        var db = this.connection.sandstormDb;                                                                          // 1513
        return SandstormPermissions.downstreamTokens(db, { grain: { _id: grainId, identityId: identityId } });         // 1514
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return transitiveShares;                                                                                           //
  }(),                                                                                                                 //
                                                                                                                       //
  newApiToken: function () {                                                                                           // 1519
    function newApiToken(provider, grainId, petname, roleAssignment, owner, unauthenticated) {                         // 1519
      check(provider, Match.OneOf({ identityId: String }, { rawParentToken: String }));                                // 1520
      // other check()s happen in SandstormPermissions.createNewApiToken().                                            //
      var db = this.connection.sandstormDb;                                                                            // 1519
      if (provider.identityId) {                                                                                       // 1523
        if (!this.userId || !db.userHasIdentity(this.userId, provider.identityId)) {                                   // 1524
          throw new Meteor.Error(403, "Not an identity of the current user: " + provider.identityId);                  // 1525
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (provider.identityId) {                                                                                       // 1529
        provider.accountId = this.userId;                                                                              // 1530
      }                                                                                                                //
                                                                                                                       //
      return SandstormPermissions.createNewApiToken(this.connection.sandstormDb, provider, grainId, petname, roleAssignment, owner, unauthenticated);
    }                                                                                                                  //
                                                                                                                       //
    return newApiToken;                                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  updateApiToken: function () {                                                                                        // 1538
    function updateApiToken(token, newFields) {                                                                        // 1538
      var db = this.connection.sandstormDb;                                                                            // 1539
                                                                                                                       //
      check(token, String);                                                                                            // 1541
      check(newFields, { petname: Match.Optional(String),                                                              // 1542
        roleAssignment: Match.Optional(db.roleAssignmentPattern),                                                      // 1543
        revoked: Match.Optional(Boolean) });                                                                           // 1544
                                                                                                                       //
      if (!this.userId) {                                                                                              // 1546
        throw new Meteor.Error(403, "Must be logged in to modify a token");                                            // 1547
      }                                                                                                                //
                                                                                                                       //
      var apiToken = db.collections.apiTokens.findOne(token);                                                          // 1550
      if (!apiToken) {                                                                                                 // 1551
        throw new Meteor.Error(404, "No such token found.");                                                           // 1552
      }                                                                                                                //
                                                                                                                       //
      if (db.userHasIdentity(this.userId, apiToken.identityId)) {                                                      // 1555
        var modifier = { $set: newFields };                                                                            // 1556
        db.collections.apiTokens.update(token, modifier);                                                              // 1557
      } else {                                                                                                         //
        throw new Meteor.Error(403, "User not authorized to modify this token.");                                      // 1559
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return updateApiToken;                                                                                             //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-permissions/permissions.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-permissions'] = {}, {
  SandstormPermissions: SandstormPermissions
});

})();

//# sourceMappingURL=sandstorm-permissions.js.map
